/*
 * ASE1804.asm
 *
 *  Created: 07/06/2018 18.46.50
 *  Author: Roberto Roncella
 *
 * Realizzare un sottoprogramma per il microcontrollore AVR XMEGA256A3BU, 
 * in grado di inserire una stringa sX all'interno di un'altra stringa sY. 
 * Una stringa, la cui massima lunghezza pu essere di 255 caratteri (codici ASCII su 8 bit), 
 *  composta da un primo byte che contiene l'indicazione della lunghezza della stringa stessa 
 * (nel caso di stringa vuota l'indicazione di lunghezza  0) 
 * seguito dai codici dei caratteri che compongono la stringa.
 * Nel registro R16 viene indicato dopo quanti caratteri deve iniziare l'inserimento. 
 * Se tale valore  uguale o maggiore del numero di caratteri di sY, 
 * la stringa sX viene posta al termine della stringa sY. 
 * Se il numero totale dei caratteri della stringa risultante supera 255, 
 * il risultato viene troncato alla lunghezza massima.
 * La stringa sX  posta in memoria a partire dall'indirizzo contenuto in X; 
 * la sY a partire dall'indirizzo contenuto in Y. 
 * Il risultato va scritto in memoria a partire dall'indirizzo contenuto in Z.
 */ 

main:
 ldi XL,low(0x2100)
 ldi XH,high(0x2100)
 ldi YL,low(0x2000)
 ldi YH,high(0x2000)
 ldi ZL,low(0x2200)
 ldi ZH,high(0x2200)
 rcall insertXinY //solo per debug
 rjmp main

/* Il compito richiesto puo` essere spezzato nella scrittura di 3 parti di lunghezza L1, L2 e L3.
 * L1 e L3 fanno riferimento a caratteri di sY, mentre L2 si riferisce a caratteri di sX.
 * Indichiamo con p l'offset con cui va inserito sX, contenuto in R16
 * I valori di L1, L2 e L3 si trovano a partire dalle seguenti relazioni
 * L1 = min{LY,p}
 * L1+L2 = min{L1+LX,255} = L12
 * L1+L2+L3 = min{LY+LX,255}= LZ
 * da cui
 * L2 = L12-L1
 * L3 = LZ-L12
 *
 */ 
 
insertXinY:
 push R16 //L1
 push R17 //L2
 push R18 //L3
 push R20 //ausiliario
 push XL //puntatore a sX
 push XH
 push YL //puntatore a sY
 push YH
 push ZL
 push ZH //puntatore al risultato sz

 ld R17,X+ //in R17 LX
 ld R18,Y+ //in R18 LY
 cp R18,R16
 brcc p1
 mov R16,R18
 p1: //in R16 ci va L1
 add R18,R17 //in R18 ci va LX+LY
 brcc p2
 ldi R18,255
 p2: //in R18 c'e` L1+L2+L3 (LZ)
 st Z+,R18 //sistemo la lunghezza del risultato
 add R17,R16 //in R17 ci va LX+L1
 brcc p3
 ldi R17,255
 p3: //in R17 ora c'e` L1+L2
 sub R18,R17 //in R18 resta L3
 sub R17,R16 //in R17 resta L2

 loop1:
 tst R16
 breq loop2
 lp1: ld R20,Y+
      st Z+,R20
      dec R16
      brne lp1
 loop2:
 tst R17
 breq loop3
 lp2: ld R20,X+
      st Z+,R20
	  dec R17
	  brne lp2
 loop3:
 tst R18
 breq end
 lp3: ld R20,Y+
      st Z+,R20
	  dec R18
	  brne lp3
 end:
 pop ZH //puntatore al risultato sz
 pop ZL
 pop YH
 pop YL //puntatore a sY
 pop XH
 pop XL //puntatore a sX
 pop R20 //ausiliario
 pop R18 //L3
 pop R17 //L2
 pop R16 //L1
 ret